#include <iostream>
#include <algorithm>
using namespace std;

const int Dim = 1001;
int a[Dim];       // inaltimile copiilor
int nr_div[Dim];  // nr_div[i] = numarul de divizori ai lui a[i]
int n;  

void SortSelMin();
int NrDiv(int n);

int main()
{
	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		nr_div[i] = NrDiv(a[i]);
	}
		
	SortSelMin();
	
	for (int i = 1; i <= n; ++i)
		cout << a[i] << ' ';
	
	return 0;
}

void SortSelMin() // O(n * n)
{		
	for (int i = 1; i < n; ++i)
		for (int j = i + 1; j <= n; ++j)
			if (nr_div[i] < nr_div[j] ||
				(nr_div[i] == nr_div[j] && a[i] > a[j])) // sort descrescator
			{
				swap(a[i], a[j]);
				swap(nr_div[i], nr_div[j]);
			}
}

int NrDiv(int n)
{
	int nr_div {0}, d;
	
	for (d = 1; d * d < n; ++d)
		if (n % d == 0)
			nr_div += 2;
	
	if (d * d == n)
		nr_div++;
		
	return nr_div;
}
