#include <iostream>
#include <algorithm>
using namespace std;

const int Dim = 1001;
int h[Dim];    // inaltimile copiilor
int ord[Dim];  // numerele de ordine ale copiilor
int n;  

void SortSelMin();

int main()
{
	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> h[i];
		ord[i] = i;
	}
		
	SortSelMin();
	
	for (int i = 1; i <= n; ++i)
		cout << ord[i] << ' ';
	
	return 0;
}

void SortSelMin() // O(n * n)
{
	int pmin; // poz minimului in intervalul [i, n]
		
	for (int i = 1; i < n; ++i)
	{
		pmin = i;
		for (int j = i + 1; j <= n; ++j)
			if (h[j] < h[pmin])
				pmin = j;
		
		if (pmin != i)
		{
			swap(h[i], h[pmin]);
			swap(ord[i], ord[pmin]);
		}
	}
}
