#include <iostream>
#include <algorithm>
using namespace std;

const int Dim = 1001;
int a[Dim], n;

void CitesteSir();
void SortSelMin();
void AfiseazaSir();

int main()
{
	CitesteSir();
	SortSelMin();
	AfiseazaSir();
}

void SortSelMin() // O(n * n)
{
	int pmin; // poz minimului in intervalul [i, n]
	
	for (int i = 1; i < n; ++i)
	{
		pmin = i;
		for (int j = i + 1; j <= n; ++j)
			if (a[j] < a[pmin])
				pmin = j;
		
		if (pmin != i)
			swap(a[i], a[pmin]);
	}
}


void AfiseazaSir()
{
	for (int i = 1; i <= n; ++i)
		cout << a[i] << ' ';
}

void CitesteSir()
{
	cin >> n;
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
}















