#include <iostream>
#include <algorithm>
using namespace std;

const int Dim = 1001;
int a[Dim];
int N;   // numarul valorilor care se citesc
int n;   // numarul valorilor prime care se citesc

bool EstePrim(int n);
void SortSelMin();

int main()
{
	cin >> N;
	int x;
	for (int i = 1; i <= N; ++i)
	{
		cin >> x;
		if (EstePrim(x))
			a[++n]= x;	   // in sirul a[] retinem unmai numerele prime
	}
		
	SortSelMin();
	
	for (int i = 1; i <= n; ++i)
		cout << a[i] << ' ';
	
	return 0;
}

void SortSelMin() // O(n * n)
{
	int pmin; // poz minimului in intervalul [i, n]
		
	for (int i = 1; i < n; ++i)
	{
		pmin = i;
		for (int j = i + 1; j <= n; ++j)
			if (a[j] < a[pmin])
				pmin = j;
		
		if (pmin != i)
			swap(a[i], a[pmin]);
	}
	
}

bool EstePrim(int n)
{
	if (n < 2)  return false;
	if (n == 2) return true;
	if (n % 2 == 0)
		return false;
		
	for (int d = 3; d * d <= n; d += 2)
		if (n % d == 0)
			return false;
	return true;
}














